clear all;
global tp ng nh tpercm Ya Xa Rg qa nfunds ntotal nmove tmod;

tper = 1; % 1 if beta over the period from mm+1 to 12; 0 of month mm+1
tfmb = 1; % 1 if Fama-MacBeth
tobj = 0;
tmod = 1;
tsubst = 0; % if 1, give 0 style rankings to funds with missing style info
toutperf = 0; % if 1, perf wrt other classes is defined as median outperformance dummy
houtliers = [];
nmove = 0; %-0.5;
nstart = 1; % 1 if start one year later and use last year style
trestr = 0;
tsim = 0;
rest = 0;
tproc = 2;

tadd(1) = 0; %input('Choose the additional terms: cash flow (1), perf*size (2), perf*age (3) \n');
index = 2;
while tadd(index-1) > 0,
   tadd(index) = input('');
   index = index+1;
end;
tadd = tadd(1:end-1);
nadd = length(tadd);
K0 = 1 + nadd;
nsim = 1000;

disp('This program estimates predictors of future performance');
tcat = 4; %input('Choose the type of the category: (1) Mstar (2) style (3) ICDI (4) SI \n');
if tcat==1,
    vcat = [11:15]; % 31:36 38:39 41:44];
elseif tcat==2,
    vcat = [1:9];
elseif tcat==3,
    vcat = [1:4];
elseif tcat==4,
    vcat = [1:6];
end;
ncat = length(vcat); % # objectives

tperf = 1; %input('Choose performance measure:\n (1) Rank; (2) Comp; (3) CompN; (4) Exp; (5) Normal; \n');
trel = 0; %input('Choose relative category:\n (0) All funds; (1) Objective; \n');
tperc = 1; %input('The number of percentiles for the piecewise linear regression (1 = linear):\n');
trisk = 1; %input('Risk is defined as total (1), systematic (2), unsystematic (3) or systematic and unsystematic (4)?\n');

y1 = 1979; %1993; %1980; % initial year
y0 = y1-1;
y2 = 2002; %1998; % final year 
ny = y2-y1+1; % # years in the returns data set

tpi = [1 3 4];
nperf = length(tpi);
tsort = 1; % 0 = not sorts, 1 = simple sort, 2 = sort excluding missing variables
tturn = 2; % if 1 replace NaN with 0, if 2 with category mean turnover
nfrac = 10; % # fractiles
tt = 36;
ttmin = 24;
tyear = tt/12;
tquarter = 4;
tindex = 4;
load factors.txt; % MKt-Rf SMB HML UMD Rf from 01/70 to 12/2002, in %
% factor returns start from the first year necessary for the regressions
Rfactor = factors(:,1:tindex); %/100; % (monthly) factor returns 1+12*(y1-1970):12*(y2-1970)
Rf = factors(:,5); %/100 + ones(12*ny,1); % (monthly) risk-free returns

load etotal.txt; % # year turn fload expense ret1-12 TNA9-12 yinc minc class MRobj MRstyle ICDI SI, from 1976 to 1999
ndata0 = 5; %# vars before returns
ndata1 = 23; %# vars before class
N = size(etotal,1); % overall #fund-year obs
load flist.txt; % # y_start m_start (data)

iquantile = 1; %nquantile; % nquantile - top, 1 - bottom
nquantile = 10;

% loading results of forecasting regressions
% first line: indexes of variables (0 for const)
% second to last lines: coefficients for each year
load flinr.txt; % linear returns
load flina.txt; % linear alpha
load ftopr.txt; % top decile returns
load ftopa.txt; % top decile alpha
load fbotr.txt; % bottom decile returns
load fbota.txt; % bottom decile alpha
pindex = [7 9 11 17 12 22 24 29 30]; % index for var-s that are present in at least one best specification

for k=1:ny,
   kk = k + y0;
   disp(kk);
   
   idx = find(etotal(:,2)==k+y0 & etotal(:,ndata1+1+tcat)>=vcat(1) & etotal(:,ndata1+1+tcat)<vcat(end)+1 & sum(isnan(etotal(:,ndata0+1:ndata0+12)),2)==0);
   % nr Ret1-12 y0 m0 obj
   A0 = etotal(idx,[1 ndata0+1:ndata0+12 ndata1-1:ndata1 ndata1+1+tcat]);
   na = size(A0,1);
   
   clear Achar Atna Areturn fcoef Arflowq Arflowy Aaflowy Aage Arety Astdy Asharpy Atotal Acurrent Atrack Arcat;
   Areturn(1:na,12*tyear) = NaN; % returns over the past tyear years
   Atna(1:na,4*tyear) = NaN; % TNA over the past tyear years
   Achar(1:na,1:4) = NaN; % Turn Mload Exp obj from the past year
   for kl=k-tyear:k-1,
       for i=1:na,
           idx = find(etotal(:,1)==A0(i,1) & etotal(:,2)==kl+y0);
           if size(idx,1)==1,
               Areturn(i,1+12*(kl-k+tyear):12+12*(kl-k+tyear)) = etotal(idx,ndata0+1:ndata0+12);
               Atna(i,1+4*(kl-k+tyear):4+4*(kl-k+tyear)) = etotal(idx,ndata0+13:ndata0+16);
               if kl==k-1, % chars from the previous year 
                   Achar(i,1:4) = etotal(idx,[3:5 ndata1+1+tcat]);
               end;
           else
               Areturn(i,1+12*(kl-k+tyear):12+12*(kl-k+tyear)) = NaN;
               Atna(i,1+4*(kl-k+tyear):4+4*(kl-k+tyear)) = NaN;
               if kl==k-1,
                   Achar(i,1:4) = NaN;
               end;
           end;
       end;
   end;
   
   % if char=NaN replace with previous year value
   for j=1:3,
       idx = find(isnan(Achar(:,j))==1);
       for i=1:length(idx),
           ix = find(etotal(:,1)==A0(idx(i),1) & etotal(:,2)==kk-2);
           if length(ix)==1 & isnan(etotal(ix,2+j))==0,
               Achar(idx(i),j) = etotal(ix,2+j);
           end;
       end;
   end;
   
   Aage = kk  - A0(:,14) - A0(:,15)/12; % age t-1
   % correcting age with flist
   as = find(Aage<0);
   for i=1:length(as),
       ix = find(flist(:,1)==A0(as(i),1));
       if A0(as(i),14) > flist(ix,2),
           Aage(as(i)) = kk - flist(ix,2) - flist(ix,3)/12; % age t-1
       else
           Aage(as(i)) = 0; % age t-1
       end;
   end;
   
   % annual return std sharp
   for i=1:tyear,
       Arety(:,i) = prod(ones(na,12)+Areturn(:,1+12*(i-1):12*i)/100,2);
       Astdy(:,i) = std(Areturn(:,1+12*(i-1):12*i),0,2);
       Asharpy(:,i) = (Arety(:,i) - prod(1+Rf(1+12*(kk-1970)-tt+12*(i-1):12+12*(kk-1970)-tt+12*(i-1))/100))./Astdy(:,i);
   end;
   
   % absolute and relative flows
   for i=1:tyear-1,
       Aaflowy(:,i) = Atna(:,4*i+4) - Atna(:,4*i).*Arety(:,i+1); % AF
%       Arflowy(:,i) = 100*(1 - Arety(:,i+1).*Atna(:,4*i)./Atna(:,4*i+4)); % disc RF
%       Arflowy(:,i) = 100*(Atna(:,4*i+4)./Atna(:,4*i) - Arety(:,i+1)); % std RF
       Arflowy(:,i) = 100*(Atna(:,4*i+4) - Atna(:,4*i).*Arety(:,i+1))./(0.5*Atna(:,4*i+4) + 0.5*Atna(:,4*i)); % modified RF, dividing by avg TNA
   end;
   for i=1:tquarter,
       as = prod(1+Areturn(:,tt+3*(i-1-tquarter)+1:tt+3*(i-tquarter))/100,2); %ones(na,3)
%       Arflowq(:,i) = 100*(1 - as.*Atna(:,end+i-1-tquarter)./Atna(:,end+i-tquarter)); % disc RF
%       Arflowq(:,i) = 100*(Atna(:,end+i-tquarter)./Atna(:,end+i-1-tquarter) - as); % std RF
       Arflowq(:,i) = 100*(Atna(:,end+i-tquarter) - Atna(:,end+i-1-tquarter).*as)./(0.5*Atna(:,end+i-tquarter) + 0.5*Atna(:,end+i-1-tquarter)); % modified RF, dividing by avg TNA
   end;
   clear as;
   Arety = 100*(Arety - 1); % in %
   Astdy = 100*Astdy;
   
%    Atotal(:,1) = 100*(prod(1+Areturn/100,2) - 1); %ones(na,tt)
%    Atotal(:,2) = std(Areturn,0,2);
   
   % alpha, betas, and unsystematic risk in past years
   rfactor1 = Rfactor(1+12*(kk-1970)-tt:12*(kk-1970),1:tindex);
   rfree1 = Rf(1+12*(kk-1970)-tt:12*(kk-1970));
   for j=1:na,
       aix = find(isnan(Areturn(j,:))==0);
       Att(j,1) = length(aix);
       if Att(j,1)>=ttmin,
           Atotal(j,1) = 100*(prod(1+Areturn(j,aix)/100,2) - 1);
           Atotal(j,2) = 100*std(Areturn(j,aix));
           rfree1sum = 100*(prod(1+rfree1(aix)/100) - 1);
           Atotal(j,3) = (Atotal(j,1) - rfree1sum)./Atotal(j,2);
           Atotal(j,4:3+tindex+2) = coef(Areturn(j,aix)'-rfree1(aix),rfactor1(aix,:)); % alpha betas sigma(eps)
           rfactor1sum = 100*(prod(1+rfactor1(aix,:)/100) - 1);
           Atotal(j,5:4+tindex) = Atotal(j,5:4+tindex).*rfactor1sum; % betas x factor premiums
       else
           Atotal(j,1:3+tindex+2) = NaN;
       end;
   end;
%    Atotal(:,5:4+tindex) = Atotal(:,5:4+tindex).*repmat(100*(prod(1+rfactor1/100,2) - 1),na,1); % betas x factor premiums
%    Atotal(:,3) = (Atotal(:,1) - 100*(prod(1+rfree1/100) - 1))./Atotal(:,2);
   
%    % overall rankings
%    Atotal(aidx2,end+1:end+3) = 
%    aidx2 = find(isnan(Atotal(:,1))==0);
%    Atotal(aidx2,end+1:end+3) = [hrank(Atotal(aidx2,1)) hrank(Atotal(aidx2,3)) hrank(Atotal(aidx2,4))];
   
   % alpha, betas, and unsystematic risk in current year
   rfactor1 = Rfactor(1+12*(kk-1970):12+12*(kk-1970),:);
   rfree1 = Rf(1+12*(kk-1970):12+12*(kk-1970));
%   rdist1 = [mean(rfactor1) std(rfactor1) mean(rfree1)];
   Acurrent(:,1) = 100*(prod(1+A0(:,2:13)/100,2) - 1);
   Acurrent(:,2) = std(A0(:,2:13),0,2);
   Acurrent(:,3) = (Acurrent(:,1) - 100*(prod(1+rfree1/100) - 1))./Acurrent(:,2);
   for j=1:na,
       Acurrent(j,4:3+tindex+2) = coef(A0(j,2:13)'-rfree1,rfactor1); % alpha betas sigma(eps)
   end;
   
   % category-level rankings and means
   s1 = size(Atotal,2);
%    Atotal(:,end+1:end+6) = NaN;
%    Arety(:,end+1:end+2*tyear) = NaN;
%    Arflowy(:,end+1:end+tyear-1) = NaN;
   Arcat(1:na,tt) = NaN; % monthly mean category return
   for j=1:ncat,
       aidx2 = find(Achar(:,4)==vcat(j) & isnan(Atotal(:,1))==0);
       nfunds(k,1+j) = length(aidx2);
       if nfunds(k,1+j)>0,
%            Atotal(aidx2,s1+1:s1+3) = [hrank(Atotal(aidx2,1)) hrank(Atotal(aidx2,3)) hrank(Atotal(aidx2,4))];
%            Atotal(aidx2,s1+4:s1+6) = [repmat(mean(Atotal(aidx2,1)),as,1) repmat(mean(Atotal(aidx2,3)),as,1) repmat(mean(Atotal(aidx2,4)),as,1)];
           for l=1:4,
               Acat(k,j,l) = mean(Atotal(aidx2,l)); % mean category Ret Std Sh Alpha
           end;
       else
           Acat(k,j,1:4) = NaN;
       end;
       aidx2 = find(Achar(:,4)==vcat(j) & isnan(Achar(:,1))==0);
       if length(aidx2)>0,
           Acat(k,j,5) = mean(Achar(aidx2,1)); % mean category Turn
       else
           Acat(k,j,5) = NaN;
       end;
       if tturn==2,
           aidx2 = find(Achar(:,4)==vcat(j) & isnan(Achar(:,1))==1);
           if isnan(Acat(k,j,5))==0,
               Achar(aidx2,1) = Acat(k,j,5);
           else
               aidx3 = find(isnan(Achar(:,1))==0);
               Achar(aidx2,1) = mean(Achar(aidx3,1));
           end;
       end;
%        for i=1:tyear,
%            aidx2 = find(Achar(:,4)==vcat(j) & isnan(Arety(:,i))==0);
%            if length(aidx2)>0,
%                Arety(aidx2,tyear+i) = hrank(Arety(aidx2,i));
%                Arety(aidx2,2*tyear+i) = mean(Arety(aidx2,i));
%            end;
%        end;
       for i=1:tyear-1,
           aidx2 = find(Achar(:,4)==vcat(j) & isnan(Aaflowy(:,i))==0);
           if length(aidx2)>0,
               Acat(k,j,5+i) = sum(Aaflowy(aidx2,i))/sum(Atna(aidx2,4+4*i)); % mean category flow
  %             Arflowy(aidx2,tyear-1+i) = Acat(k,j,6); %mean(Arflowy(aidx2,i));
           else
               Acat(k,j,5+i) = NaN;
           end;
       end;
       for i=1:tt,
           aidx2 = find(Achar(:,4)==vcat(j) & isnan(Areturn(:,i))==0);
           if length(aidx2)>0,
               Arcat(aidx2,i) = mean(Areturn(aidx2,i));
           end;
       end;
   end;
   
   % tracking error
   Atrack = std(Areturn-Arcat,0,2);
   
%    % top category dummy
%    amax = max(Atotal(:,s1+4:s1+6));
%    Atotal(:,end+1:end+3) = 0;
%    for i=1:3,
%        aidx = find(Atotal(:,s1+3+i)==amax(i));
%        Atotal(aidx,s1+6+i) = 1;
%    end;
%    amax = max(Arflowy(:,1+tyear-1:2*(tyear-1)));
%    Arflowy(:,end+1:end+tyear-1) = 0;
%    for i=1:tyear-1,
%        aidx = find(Arflowy(:,i+tyear-1)==amax(i));
%        Arflowy(aidx,2*(tyear-1)+i) = 1;
%    end;
   
   % regressions
   %A = [Acurrent(:,[1 3 4]) Atna(:,end) Aage Achar(:,1:3) Atrack Arflowy Arety Astdy Asharpy Atotal];
   if tturn == 1,
       as = find(isnan(Achar(:,1))==1);
       Achar(as,1) = 0;
   end;
% const	TNA	Age	Turnover	Mload	Expense ratio	Tracking error	Rflow -1	CatRflow -1	Ret -1	CatRet -1	Tstd	Tsharpe	alpha	beta1	beta2	beta3	beta4	nonsyst risk	alpha / nonsyst	CatTsharpe	CatTalpha
%   A = [Acurrent(:,tpi) Atna(:,end) Aage Achar(:,1:3) Atrack Arflowy(:,[2 4]) Arety(:,[3 9]) Atotal(:,[2:10 15:16])];
% const	TNA	Age	Turnover	Mload	Expense ratio	Tracking error	Rflow -1	Rflow -2	Ret -1	Ret -2	Ret -3	Tstd	Tsharpe	alpha	beta1	beta2	beta3	beta4	nonsyst risk	appraisal ratio
%   A = [Acurrent(:,tpi) 1e-3*Atna(:,end) Aage Achar(:,1:3) Atrack Arflowy(:,[2 1]) Arety(:,[3 2 1]) Atotal(:,[2:10])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% const	TNA	Age	Turnover Mload	Expense ratio	Tracking error	Rflow -1	TRet 	Tstd	Tsharpe	alpha	nonsyst risk
%   A = [Acurrent(:,tpi) 1e-3*Atna(:,end) Aage Achar(:,1:3) Atrack Arflowy(:,2) Atotal(:,[1:4 9])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% const logTNA Age Turnover Mload Expense Tracking error RflowQ -1 Rflow -1 Ret -1 Ret -2 Ret -3 Tstd alpha nonsyst risk
%   A = [Acurrent(:,tpi) log(Atna(:,end)) Aage Achar(:,1:3) Atrack Arflowq(:,end) Arflowy(:,2) Arety(:,[3 2 1]) Atotal(:,[2 4 9])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% const a*logTNA a*Age a*Turnover a*Mload a*Expense Track_error RflowQ -1 Rflow -1 Ret -1 Ret -2 Ret -3 Tstd alpha nonsyst risk
%   A = [Acurrent(:,tpi) Atotal(:,2).*log(Atna(:,end)) Atotal(:,2).*Aage Atotal(:,2).*Achar(:,1) Atotal(:,2).*sign(Achar(:,2)) Atotal(:,2).*Achar(:,3) Atrack Arflowq(:,end) Arflowy(:,2) Arety(:,[3 2 1]) Atotal(:,[2 4 9])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% const logTNA Age Turnover Mload Expense a*logTNA a*Age a*Turnover a*Mload a*Expense Track_error RflowQ -1 Rflow -1 Ret -1 Ret -2 Ret -3 Tstd alpha nonsyst risk
%   A = [Acurrent(:,tpi) log(Atna(:,end)) Aage Achar(:,1:3) Atotal(:,2).*log(Atna(:,end)) Atotal(:,2).*Aage Atotal(:,2).*Achar(:,1) Atotal(:,2).*sign(Achar(:,2)) Atotal(:,2).*Achar(:,3) Atrack Arflowq(:,end) Arflowy(:,2) Arety(:,[3 2 1]) Atotal(:,[2 4 9])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% const logTNA Age Turnover Mload Expense Ret*logTNA Ret*Age Ret*Turnover Ret*Mload Ret*Expense Track_error RflowQ -1 Rflow -1 Ret -1 Ret -2 Ret -3 Tstd alpha nonsyst risk
%   A = [Acurrent(:,tpi) log(Atna(:,end)) Aage Achar(:,1:3) Atotal(:,1).*log(Atna(:,end)) Atotal(:,1).*Aage Atotal(:,1).*Achar(:,1) Atotal(:,1).*sign(Achar(:,2)) Atotal(:,1).*Achar(:,3) Atrack Arflowq(:,end) Arflowy(:,2) Arety(:,[3 2 1]) Atotal(:,[2 4 9])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% const	logTNA	Age	Turnover	MloadDum	Expense ratio	Tracking error	RflowQ -1	Treturn	Tstd	alpha	nonsyst risk
%   A = [Acurrent(:,tpi) log(Atna(:,end)) Aage Achar(:,1) sign(Achar(:,2)) Achar(:,3) Atrack Arflowq(:,end) Atotal(:,[1 2 4 9])]; % log(1e-3*Atna(:,end)) log(1+Aage) 
% overall matrix
% current Ret Sharpe Alpha - # SI - TNA	Age	Turnover	Mload	Expense	RetY RflowY RflowQ - Total ret	std	sharpe alpha	betas*factor nonsyst Track_error
   A = [Acurrent(:,[tpi end]) A0(:,1) Achar(:,4) Atna(:,end) Aage Achar(:,1:3) fliplr(Arety(:,1:tyear)) fliplr(Arflowy(:,1:tyear-1)) fliplr(Arflowq) Atotal(:,[1:9]) Atrack];

%   as = find(isnan(A(:,3))==0); % leaving funds with at least 2-year history
%   as = find(isnan(sum(A,2))==0);
   as = find(isnan(sum(A(:,pindex),2))==0);
   A = A(as,:);
   n = size(A,1);
   nfunds(k,1) = n;
   
   % cumulative matrix
   AA(1+sum(nfunds(1:k-1,1)):sum(nfunds(1:k,1)),:) = A;
   
   % forming ptf
   nlag = 4;
   ilag = [max(2,k-nlag):k];
 if k>1,
   rcurrent = A0(as,2:13);
%    A = A(as,:);
%    rcurrent = rcurrent(as,:);
   for t=1:4+length(pindex),
       if t==1, % linear return
           pred1 = A(:,flinr(1,2:end))*mean(flinr(ilag,2:end),1)' + mean(flinr(ilag,1));
           pred2 = pred1;
       elseif t==2, % linear alpha
           pred1 = A(:,flina(1,2:end))*mean(flina(ilag,2:end),1)' + mean(flina(ilag,1));
           pred2 = pred1;
       elseif t==3, % decile return
           pred1 = A(:,ftopr(1,2:end))*mean(ftopr(ilag,2:end),1)' + mean(ftopr(ilag,1));
           pred1 = pred1 +(qdummy(A(:,ftopr(1,4)),10,10) - A(:,ftopr(1,4)))*mean(ftopr(ilag,4));
           pred2 = - A(:,fbotr(1,2:end))*mean(fbotr(ilag,2:end),1)' + mean(fbotr(ilag,1));
           pred2 = pred2 +(qdummy(A(:,fbotr(1,4)),10,1) - A(:,ftopr(1,4)))*mean(ftopr(ilag,4));
       elseif t==4, % decile alpha
           pred1 = A(:,ftopa(1,2:end))*mean(ftopa(ilag,2:end),1)' + mean(ftopa(ilag,1));
           pred2 = - A(:,fbota(1,2:end))*mean(fbota(ilag,2:end),1)' + mean(fbota(ilag,1));
       elseif t>4, % chars
           pred1 = A(:,pindex(t-4));
           pred2 = pred1;
       end;
       idx1 = find(pred1>quantile(pred1,(nquantile-1)/nquantile,3));
       idx2 = find(pred2<=quantile(pred2,1/nquantile,3));
       Rout1(1+12*(k-1):12*k,t) = mean(rcurrent(idx1,:))';
       Rout2(1+12*(k-1):12*k,t) = mean(rcurrent(idx2,:))';
   end;
   Rout0(1+12*(k-1):12*k,1) = mean(rcurrent)';
end;

   as = find(isnan(sum(A,2))==0);
   A = A(as,:);
   n = size(A,1);
   
  for j=1:nperf,
   y = A(:,j);
   X = [ones(n,1) A(:,7:11)];
   
   % estimation
   [N,K] = size(X);
   if tproc == 2, % WLS
       b = (X'*X)\(X'*y);
       rest0(k,1+K*(j-1):K*j) = b';
       u = y - X*b; % residuals
       Xu = X;
       bu = (Xu'*Xu)\(Xu'*log(u.^2)); %abs(u)
       W12 = sqrt(exp(Xu*bu));
       clear Xu;
       y = y./W12;
       X = X./repmat(W12,1,K);
   end;
   outmax(k,:) = [max(y) max(X(:,2:end))];
   outmin(k,:) = [min(y) min(X(:,2:end))];
   b = (X'*X)\(X'*y);
   RSS = norm(X*b-mean(y))^2;  % Residual sum of squares.
   TSS = norm(y-mean(y))^2;     % Total sum of squares.
   r22(k,j) = RSS/TSS;                % R-square statistic.
   %rest(2*k-1:2*k,1+K*(t-1):K*t) = [b(1:K0) b(1:K0)./sqrt(diag(Vbh1:K0,1:K0)))]';
   rest(k,1+K*(j-1):K*j) = b';
  end;

   nq = repmat(floor(n/nfrac),1,nfrac);
   nedge = floor(n/20); % top and bottom 5%
   nq(1:n-nfrac*nq(1)) = nq(1:n-nfrac*nq(1)) + 1;
   M = size(A,2) - 3;
   
if tsort==1,
    % explanatory variables for return fractiles
    for ij=1:3,
        A = sortrows(A,tpi(ij)); % sorting by return / sharpe / alpha
        for i=1:M,
            rsort(1,i+M*(k-1),ij) = mean(A(1:nedge,3+i));
            for j=1:nfrac,
                rsort(j+1,i+M*(k-1),ij) = mean(A(sum(nq(1:j-1))+1:sum(nq(1:j)),3+i));
            end;
            rsort(nfrac+2,i+M*(k-1),ij) = mean(A(end-nedge+1:end,3+i));
        end;
    end;
elseif tsort==2,% excluding NaN for each variable
    for ij=1:3,
        A = sortrows(A,tpi(ij)); % sorting by return / sharpe / alpha
        for i=1:M,
            as = A(:,3+i);
            nchar(k,i) = length(find(isnan(as)==0));
            as = A(1:nedge,3+i);
            ix = find(isnan(as)==0);
            if length(ix) > 0,
                rsort(1,i+M*(k-1),ij) = mean(as(ix));
            end;
            for j=1:nfrac,
                as = A(sum(nq(1:j-1))+1:sum(nq(1:j)),3+i);
                ix = find(isnan(as)==0);
                if length(ix) > 0,
                    rsort(j+1,i+M*(k-1),ij) = mean(as(ix));
                end;
            end;
            as = A(end-nedge+1:end,3+i);
            ix = find(isnan(as)==0);
            if length(ix) > 0,
                rsort(nfrac+2,i+M*(k-1),ij) = mean(as(ix));
            end;
        end;
    end;
end;
   
end;

nlag = 5;
Rout = [Rout1 Rout2 Rout1-Rout2 Rout0];
save frout.txt Rout -ASCII -TABS;
Rout = Rout(1+12*nlag:end,:);
[T K] = size(Rout);
Rfactor0 = [ones(12*(ny-nlag),1) Rfactor(1+12*(y1+nlag-1970):12*(y2+1-1970),:)];
Rf0 = Rf(1+12*(y1+nlag-1970):12*(y2+1-1970),:);
for i=1:3,
    if i==1,
        idx = [1:T];
    elseif i==2,
        idx = [1:round(T/2)];
    elseif i==3,
        idx = [1+round(T/2):T];
    end;
    Rsum(1:K,1,i) = 12*mean(Rout(idx,:))';
    Rsum(1:K,2,i) = 12*std(Rout(idx,:))';
    Rsum(1:K,3,i) = (Rsum(1:K,1,i) - 12*mean(Rf0(idx)))./Rsum(1:K,2,i); % Sharpe repmat(Rf,1,K))';
    for j=1:K,
       results = ols(Rout(idx,j)-Rf0(idx,:),Rfactor0(idx,:)); % alpha betas 
       Rsum(j,4:3+tindex+2,i) = [results.beta(1) abs(results.tstat(1)) results.beta(2:end)'];
   end;
end;
Rsum = [Rsum(:,:,1) Rsum(:,1:5,2) Rsum(:,1:5,3)];
save frsum.txt Rsum -ASCII -TABS;


save fnfunds.txt nfunds -ASCII -TABS;
save g2work AA nfunds Acat;

ntotal = sum(nfunds(:,1));
K = size(rest,2);
restf = sum(rest.*repmat(nfunds(:,1),1,K)) / ntotal;
restf0 = mean(rest);
restfm = rest - repmat(restf,ny,1);
restv = restfm'*diag(nfunds(:,1).^2)*restfm/ntotal^2;
rests = sqrt(diag(restv))';
rests0 = std(rest)/sqrt(ny);
%    rests = sqrt(sum(((rest - repmat(restf,ny,1)).^2).*repmat(nfunds,1,K)) / ntotal) / sqrt(ny);
restt = abs(restf./rests);
restp = 1 - normcdf(restt);
restt0 = abs(restf0./rests0);
restp0 = 1 - normcdf(restt0);
restz = [restf' restp' restf0' restp0']; % restt' restt0'

restt = rest;
rest = rest0;
restf = sum(rest.*repmat(nfunds(:,1),1,K)) / ntotal;
restf0 = mean(rest);
restfm = rest - repmat(restf,ny,1);
restv = restfm'*diag(nfunds(:,1).^2)*restfm/ntotal^2;
rests = sqrt(diag(restv))';
rests0 = std(rest)/sqrt(ny);
%    rests = sqrt(sum(((rest - repmat(restf,ny,1)).^2).*repmat(nfunds,1,K)) / ntotal) / sqrt(ny);
restt = abs(restf./rests);
restp = 1 - normcdf(restt);
restt0 = abs(restf0./rests0);
restp0 = 1 - normcdf(restt0);
restz = [restz restf' restp' restf0' restp0']; % restt' restt0'
%disp('Fama-MacBeth results:');
%disp(restz);
save fregsum.txt restz -ASCII -TABS;


if tsort==2,
nchar = [nfunds nchar];
save fnchar.txt nchar -ASCII -TABS;
end;

if tsort>0,
    T = length(nfunds);
    rsort = rsort/T; %[rsort1' rsort2' rsort3'] / T;
    for ij=1:3,
        %save fsort.txt rsort -ASCII -TABS;
        rtemp = reshape(rsort(:,:,ij)',M*(nfrac+2),T);
        % equal-weighted
        rmean = mean(rtemp,2);
        %rstd = std(rtemp,0,2) / sqrt(T);
        reste(:,:,ij) = [reshape(rmean,M,nfrac+2)]; % reshape(rstd,M,nfrac+2)];
        % #funds-weighted
        % rmean = sum(rtemp.*repmat(nfunds',M*(nfrac+2),1),2) / sum(nfunds);
        % restf = [reshape(rmean,M,nfrac+2)]; % reshape(rstd,M,nfrac+2)];
    end;
    reste = [reste(:,:,1) reste(:,:,2) reste(:,:,3)];
    save fsorts.txt reste -ASCII -TABS;
end;