clear all;
global tp ng nh tpercm Ya Xa Rg qa nfunds ntotal nmove tmod;

tper = 1; % 1 if beta over the period from mm+1 to 12; 0 of month mm+1
tfmb = 1; % 1 if Fama-MacBeth
tobj = 0;
tmod = 1;
tsubst = 0; % if 1, give 0 style rankings to funds with missing style info
toutperf = 0; % if 1, perf wrt other classes is defined as median outperformance dummy
houtliers = [];
nmove = 0; %-0.5;
nstart = 1; % 1 if start one year later and use last year style
trestr = 0;
tsim = 0;
rest = 0;
tproc = 2;

disp('This program estimates predictors of future performance');
tcat = 4; %input('Choose the type of the category: (1) Mstar (2) style (3) ICDI (4) SI \n');
if tcat==1,
    vcat = [11:15]; % 31:36 38:39 41:44];
elseif tcat==2,
    vcat = [1:9];
elseif tcat==3,
    vcat = [1:4];
elseif tcat==4,
    vcat = [1:6];
end;
ncat = length(vcat); % # objectives

tperf = 1; %input('Choose performance measure:\n (1) Rank; (2) Comp; (3) CompN; (4) Exp; (5) Normal; \n');
trel = 0; %input('Choose relative category:\n (0) All funds; (1) Objective; \n');
tperc = 1; %input('The number of percentiles for the piecewise linear regression (1 = linear):\n');
trisk = 1; %input('Risk is defined as total (1), systematic (2), unsystematic (3) or systematic and unsystematic (4)?\n');

y1 = 1979; %1993; %1980; % initial year
y0 = y1-1;
y2 = 2002; %1998; % final year 
ny = y2-y1+1; % # years in the returns data set

tpi = [1 3 4];
nperf = length(tpi);
tsort = 1; % 0 = not sorts, 1 = simple sort, 2 = sort excluding missing variables
tturn = 2; % if 1 replace NaN with 0, if 2 with category mean turnover
nfrac = 10; % # fractiles
tt = 36;
ttmin = 24;
tyear = tt/12;
tquarter = 4;
tindex = 4;
load factors.txt; % MKt-Rf SMB HML UMD Rf from 01/70 to 12/2002, in %
% factor returns start from the first year necessary for the regressions
Rfactor = factors(:,1:tindex); %/100; % (monthly) factor returns 1+12*(y1-1970):12*(y2-1970)
Rf = factors(:,5); %/100 + ones(12*ny,1); % (monthly) risk-free returns

load g2work
nfunds0 = nfunds;
clear nfunds;

AA(:,10) = sign(AA(:,10)); % Mload dummy
AA(:,15:20) = 1e-2*AA(:,15:20); % RF in fractions
AA(:,7) = 1e-3*AA(:,7); % TNA in billions
%   X(:,2) = log(X(:,2)); % logTNA
nquantile = 10;
tmethod = 2; % 1=LS 2=logit

%   A = AA(1+sum(nfunds0(1:k-1,1)):sum(nfunds0(1:k,1)),[1:4 7:11 15:16 12:14 22 24 29:end]);
% pindex = [7:11 15:16 22 24:30]; % betas
% pindex = [7:11 17 15:16 12:14 22 24 29:30]; % basic%
% pindex = [7:9 11 17 15:16 12:14 22 24 29:30]; % Mload out
% pindex = [7:9 11 17 15 12:13 22 24 29:30]; % Mload RF-2 R-3 out
% pindex = [7:9 11 17 15 12 22 24 29:30]; % Mload RF-2 R-3 R-2 out
% pindex = [7 9 11 17 15 12 22 24 29:30]; % age Mload RF-2 R-3 R-2 out
pindex = [7 9 11 17 12 22 24 29:30]; % basic
pindex = [7 9 11 17 12 22 29:30]; % alpha out
pindex = [7 9 11 17 12 22 29]; % track out, final ret
% pindex = [7 9 11 12 22 24 29:30]; % RFQ
% pindex = [9 11 12 22 24 29:30]; % TNA
% pindex = [9 11 12 24 29:30]; % std
% pindex = [9 11 12 24 30]; % seps
% pindex = [11 17 12 24]; % min
% % RFQ not dummy
% pindex = [9 11 17 12 22 24 29:30]; % TNA
% pindex = [9 11 17 12 24]; % std seps track
%pindex = [11 17 12 24]; % final, alpha

% top decile
% pindex = [9 11 17 12 22 24 29:30]; % TNA out
% pindex = [9 11 17 12 22 29:30]; % alpha out
%  pindex = [9 11 17 12 22 30]; % seps out, final ret
%  pindex = [9 11 12 24 29:30]; % RFQ & std out, final alpha

% % bottom
% pindex = [7:11 17 15 12:13 22 24 29:30]); % RF-2 R-3 out
% pindex = [7:11 17 12 22 24 29:30]); % RF-1-2 R-2-3 out
% pindex = [8:11 17 12 22 24 29:30]; % TNA out
% pindex = [8 9 11 17 12 22 24 29:30]; % Mload out
% pindex = [9 11 17 12 22 24 29:30]; % age out
% pindex = [9 11 17 12 22 29]; % final return
%pindex = [9 11 22 24 29:30]; % final alpha

idummy = []; %find(pindex>14 & pindex<21);
iquantile = 1; %nquantile; % nquantile - top, 1 - bottom

for k=1:ny,
   kk = k + y0;
   
   % cumulative matrix
   As = AA(1+sum(nfunds0(1:k-1,1)):sum(nfunds0(1:k,1)),:);
   A = AA(1+sum(nfunds0(1:k-1,1)):sum(nfunds0(1:k,1)),[1 3 2 4 pindex]);
   as = find(isnan(sum(A,2))==0);
   A = A(as,:);
   As = As(as,:);
   n = size(A,1);
   nfunds(k,1) = n;
   X = [ones(n,1) A(:,5:end)];
   %nn(k,1) = sum(X(:,5))/n;
   
   % quantile dummies
   for i=1:length(idummy),
       X(:,idummy(i)+1) = qdummy(X(:,idummy(i)+1),nquantile,iquantile);
   end;
   outmax(k,:) = max(A);
   outmin(k,:) = min(A);
   
   for j=1:2, %nperf,
       y = A(:,j);
       
       % LS
       [N,K] = size(X);
       if tproc == 2, % WLS
           b = (X'*X)\(X'*y);
           rest(k,1+K*(j-1):K*j,1) = b';
           RSS = norm(X*b-mean(y))^2;  % Residual sum of squares.
           TSS = norm(y-mean(y))^2;     % Total sum of squares.
           r22(k,j,1) = RSS/TSS;                % R-square statistic.
           r22(k,j,1) = 1 - (1 - r22(k,j,1))*(N-1)/(N-K); % adjusted R2
           u = y - X*b; % residuals
           Xu = X;
           bu = (Xu'*Xu)\(Xu'*log(u.^2)); %abs(u)
           W12 = sqrt(exp(Xu*bu));
           clear Xu;
           %       W12 = A(:,4); % weigh by Seps
           y = y./W12;
           X = X./repmat(W12,1,K);
       end;
       b = (X'*X)\(X'*y);
       RSS = norm(X*b-mean(y))^2;  % Residual sum of squares.
       TSS = norm(y-mean(y))^2;     % Total sum of squares.
       r22(k,j,2) = RSS/TSS;                % R-square statistic.
       r22(k,j,2) = 1 - (1 - r22(k,j,2))*(N-1)/(N-K); % adjusted R2
       %rest(2*k-1:2*k,1+K*(t-1):K*t) = [b(1:K0) b(1:K0)./sqrt(diag(Vbh1:K0,1:K0)))]';
       rest(k,1+K*(j-1):K*j,2) = b';
       
       % logit & probit
       result = logit(qdummy(y,nquantile,iquantile),X,300,1e-6);
       regit(k,1+K*(j-1):K*j,1) = result.beta';
       r22s(k,j,1) = result.r2mf;
       rtest(k,j,1) = result.lratio;
       
       result = probit(qdummy(y,nquantile,iquantile),X,300,1e-6);
       regit(k,1+K*(j-1):K*j,2) = result.beta';
       r22s(k,j,2) = result.r2mf;
       rtest(k,j,2) = result.lratio;
   end;
   
   factor1(k,1) = sum(Rfactor(1+12*(kk-1970):12+12*(kk-1970),1));
   
end;

save fnfunds.txt nfunds -ASCII -TABS;

ntotal = sum(nfunds(:,1));
K = size(rest,2);
for i=1:2,
    resta = rest(:,:,i);
%     restf = sum(resta.*repmat(nfunds(:,1),1,K)) / ntotal;
%     restfm = resta - repmat(restf,ny,1);
%     restv = restfm'*diag(nfunds(:,1).^2)*restfm/ntotal^2;
%     rests = sqrt(diag(restv))';
%     %    rests = sqrt(sum(((rest - repmat(restf,ny,1)).^2).*repmat(nfunds,1,K)) / ntotal) / sqrt(ny);
%     restt = abs(restf./rests);
%     restp = 1 - normcdf(restt);
    restf0 = mean(resta);
    rests0 = std(resta)/sqrt(ny);
    restt0 = abs(restf0./rests0);
    restp0 = 1 - normcdf(restt0);
    restz(:,:,i) = [restf0' restp0']; % restf' restp' 
    % logit probit
    idx = find(isnan(sum(regit(:,:,i),2))==0);
    resta = regit(idx,:,i);
    restf0 = mean(resta);
    rests0 = std(resta)/sqrt(length(idx));
    restt0 = abs(restf0./rests0);
    restp0 = 1 - normcdf(restt0);
    regitz(:,:,i) = [restf0' restp0']; % restt' restt0'
end;
restz = [restz(:,:,2) restz(:,:,1)];
r22m = [mean(r22(:,1:2,2)) mean(r22(:,1:2,1))];
%regitz = [regitz(:,:,1) regitz(:,:,2)];
r22sm = [mean(r22s(:,:,1)) mean(r22s(:,:,2))];

for ttime=1:4,
    if ttime==1, % first half
        idx = [1:round(ny/2)];
    elseif ttime==2, % second half
        idx = [round(ny/2)+1:ny];
    elseif ttime==3, % bull
        idx = find(factor1>=0);
    elseif ttime==4, % bear
        idx = find(factor1<0);
    end;
    resta = rest(idx,:,2);
    restf0 = mean(resta);
    rests0 = std(resta)/sqrt(length(idx));
    restt0 = abs(restf0./rests0);
    restp0 = 1 - normcdf(restt0);
    restz = [restz restf0' restp0']; % restt' restt0'
    r22m = [r22m mean(r22(idx,1:2))];
    
    % logit or probit
    rsize = size(regitz,2);
    for i=1:2,
        resta = regit(idx,:,i);
        idx = find(sum(isnan(resta),2)==0);
        resta = resta(idx,:);
        restf0 = mean(resta);
        rests0 = std(resta)/sqrt(length(idx));
        restt0 = abs(restf0./rests0);
        restp0 = 1 - normcdf(restt0);
        regitz(:,rsize+1:rsize+2,i) = [restf0' restp0'];
    end;
end;

regitz = [regitz(:,:,1) regitz(:,:,2)];
% restz = [restz regitz];
% r22m = [r22m r22sm];
disp(r22m(1:3));
%save fregsum.txt restz r22m -ASCII -TABS;
%save fregsum.txt regitz r22sm -ASCII -TABS;
save fregsum.txt restz r22m -ASCII -TABS;

pindex = [0 pindex];
% fres = [pindex' regit(:,1+size(regit,2)/2:end,1)']';
% fres = [pindex' regit(:,1:size(regit,2)/2,1)']';
fres = [pindex' rest(:,1:size(regit,2)/2,2)']';
%fres = [pindex' rest(:,1+size(regit,2)/2:end,2)']';
save fres.txt fres -ASCII -TABS;
