function [zz] = quantile(z,qmax,q)
% output: 1 for elements in q-th quantile out of qmax, 0 otherwise - if q > 0
% output: 1 for elements in q-th quantile out of qmax, 0 otherwise - for each quantile, if q = 0
N = size(z,1);
nq = repmat(floor(N/qmax),1,qmax); % # obsvs in each quantile
nq(1:N-sum(nq)) = nq(1) + 1;

zsort = sort(z);
if q>0,
    idx = find(z>zsort(1+sum(nq(1:q-1)))-1e-8 & z<=zsort(sum(nq(1:q))));
    zz = zeros(N,1);
    zz(idx,1) = 1;
else
    zz = zeros(N,qmax);
    for i=1:qmax,
        idx = find(z>zsort(1+sum(nq(1:i-1)))-1e-8 & z<=zsort(sum(nq(1:i))));
        zz(idx,i) = 1;
    end;
end;
